



typedef  unsigned* ULONG_PTR;
#include <windows.h>
#include <tchar.h>
#include <gdiplus.h>
#include <stdlib.h>
#include <time.h>
#include <stdio.h>
#include "PointList.h"
#include "mygraphplus.h"
#include "myfill.h"
#include "resource.h"
#include "SetScaleDialog.h"

#include "myscale.h"
#include "AboutDialog.h"

using namespace Gdiplus;

HINSTANCE hInst;


int width = 0, height = 0;

POINT *points=NULL;
int countpoints=0;
int maxpoints=128;

TCHAR s[100];
SCALE scale;
POINT scalef;//   



void RedrawAll(HWND hWnd)
{
	HDC hdc=GetDC(hWnd);
	RECT rt;
	rt.left=0;
	rt.top=0;
	rt.right=width;
	rt.bottom =height;
	FillRect(hdc,&rt,(HBRUSH)GetStockObject(WHITE_BRUSH));
	Graphics grfx(hdc);
	Pen  pen(Color(255, 0, 0));
	Bitmap *bmp=new Bitmap(width,height);
	Graphics gbmp(bmp);

	UINT* pixels;
	BitmapData bitmapData;
	Rect rect(0, 0, width, height);
	DWORD tm1 = GetTickCount();
	bmp->LockBits(				//        Bitmap-
      &rect,
      ImageLockModeWrite,
      PixelFormat32bppARGB,
      &bitmapData);
	pixels = (UINT*)bitmapData.Scan0;	//      


	//POINT  tops[11]={{100,10},{200,30},{250,100},{300,50},{280,200},{200,250},{150,120},{150,230},{100,230},{50,105},{100,10}};

	//memset(pixels,0xFF,sizeof(UINT)*width*height);


	if (countpoints>=2)
	Fill(pixels,width,height,points,countpoints,0xff000000);



	bmp->UnlockBits(&bitmapData);	//    

	const SM=5;
	
	grfx.DrawImage(bmp, 0, 0);		//   Bitmap-

	grfx.DrawRectangle(&pen,scalef.x-SM,scalef.y-SM,SM+SM,SM+SM);

	//SelectObject(hdc,GetStockObject(BLACK_BRUSH));
	//Polygon(hdc,points,countpoints);
	ReleaseDC(hWnd,hdc);
	delete bmp;
}



LRESULT CALLBACK WndProc(HWND, UINT, WPARAM, LPARAM);

INT WINAPI WinMain(HINSTANCE hInstance, HINSTANCE, PSTR, INT iCmdShow)
{
   HACCEL hAccel=0;
   HWND                hWnd;
   MSG                 msg;
   WNDCLASS            wndClass;
   GdiplusStartupInput gdiplusStartupInput;
   ULONG_PTR           gdiplusToken;
   TCHAR *lpszClassName= TEXT("  2");

   hInst=hInstance;
   countpoints=0;
   points=new POINT[maxpoints];
   /*
   points[0].x=100;
   points[0].y=200;
   points[1].x=100;
   points[1].y=100;
   points[2].x=200;
   points[2].y=100;
   points[3].x=200;
   points[3].y=200;
   points[4].x=120;
   points[4].y=120;
   points[5].x=180;
   points[5].y=120;
   //points[6].x=160;
   //points[6].y=189;
   //countpoints=6;
*/
   //  GDI+.
   GdiplusStartup(&gdiplusToken, &gdiplusStartupInput, NULL);
   
   wndClass.style          = CS_HREDRAW | CS_VREDRAW;
   wndClass.lpfnWndProc    = WndProc;
   wndClass.cbClsExtra     = 0;
   wndClass.cbWndExtra     = 0;
   wndClass.hInstance      = hInstance;
   wndClass.hIcon          = LoadIcon(NULL, IDI_APPLICATION);
   wndClass.hCursor        = LoadCursor(NULL, IDC_ARROW);
   wndClass.hbrBackground  = (HBRUSH)(COLOR_WINDOW+1);
   wndClass.lpszMenuName   =  (LPCSTR)IDR_MYMENU;
   wndClass.lpszClassName  = lpszClassName;
   
   RegisterClass(&wndClass);
   
   hWnd = CreateWindow(
      lpszClassName,   // window class name
      lpszClassName,  // window caption
      WS_OVERLAPPEDWINDOW,      // window style
      CW_USEDEFAULT,            // initial x position
      0,            // initial y position
      CW_USEDEFAULT,            // initial x size
      0,            // initial y size
      NULL,                     // parent window handle
      NULL,                     // window menu handle
      hInstance,                // program instance handle
      NULL);                    // creation parameters
	  
   ShowWindow(hWnd, iCmdShow);
   UpdateWindow(hWnd);
   
   hAccel=  LoadAccelerators(hInstance,(LPCTSTR)IDR_MAINACCELERATOR);


   while(GetMessage(&msg, NULL, 0, 0))
   {
	   if (!TranslateAccelerator(msg.hwnd ,hAccel,&msg))
	   {
	     	TranslateMessage(&msg);
	  	    DispatchMessage(&msg);
	   }
   }
   
   //   GDI+
   GdiplusShutdown(gdiplusToken);
   return msg.wParam;
}  // WinMain

LRESULT CALLBACK WndProc(HWND hWnd, UINT message, 
   WPARAM wParam, LPARAM lParam)
{
   HDC          hdc;
   PAINTSTRUCT  ps;
   //DWORD tm;
   //TCHAR ch;
   //TCHAR st[200];
   //TCHAR title[200];
   //double timeOne;
   switch(message)
   {
   case WM_COMMAND:
	   switch (LOWORD(wParam))
	   {
	   case IDM_SETSCALE:
		   SCALE * sc;
		   sc=(SCALE *)DialogBox(hInst,(LPCTSTR)IDD_SETSCALE,hWnd,(DLGPROC)SetScaleDialogProc);
		   if (!sc) break;
		   memcpy(&scale,sc,sizeof(scale));
		   Scale(points,countpoints,scale.sx,scale.sy,scalef.x ,scalef.y);
		   break;
	   case IDM_REMOVEALLPOINTS:
		   countpoints=0;
		   RedrawAll(hWnd);
		   break;
	   case IDM_TESTGDI:
		   
		   hdc=GetDC(hWnd);
		   SelectObject(hdc,GetStockObject(BLACK_BRUSH));
		   int m;
		   DWORD time1,time2;
		   time1=GetTickCount();
		   for (m=0; m<100; m++)
		   {
			   for (int n=0; n<maxpoints; n++)
			   {
				   points[n].x=rand()%(width-1);
				   points[n].y=rand()%(height-1);
				   
			   }
			   Polygon(hdc,points,maxpoints);
		   }
		   
		   time2=GetTickCount();
		   wsprintf(s,TEXT(" GDI\n %i"),time2-time1);
		   MessageBox(hWnd,s,s,MB_OK);
		   ReleaseDC(hWnd,hdc);
		   countpoints=maxpoints;
		   break;
	   case IDM_TESTGDIBMP:
		   hdc=GetDC(hWnd);
		   HDC hdcmem;
		   HBITMAP hbmp;
		   hdcmem=CreateCompatibleDC(hdc);
		   hbmp=CreateCompatibleBitmap(hdc,width,height);
		   
		   SelectObject(hdcmem,hbmp);
		   SetMapMode(hdcmem,GetMapMode(hdc));

		   SelectObject(hdcmem,GetStockObject(BLACK_BRUSH));
		   time1=GetTickCount();
		   for (m=0; m<100; m++)
		   {
			   for (int n=0; n<maxpoints; n++)
			   {
				   points[n].x=rand()%(width-1);
				   points[n].y=rand()%(height-1);
				   
			   }
			   Polygon(hdcmem,points,maxpoints);
		   }
		   
		   time2=GetTickCount();
		   wsprintf(s,TEXT(" GDI\n %i"),time2-time1);
		   MessageBox(hWnd,s,s,MB_OK);
		   countpoints=maxpoints;

		   BitBlt(hdc,0,0,width,height,hdcmem,width,height,SRCCOPY);
		   DeleteDC(hdcmem);
		   DeleteObject(hbmp);
		   ReleaseDC(hWnd,hdc);
		   
		   break;
	   case IDM_TESTMY:
		   {
		   	hdc=GetDC(hWnd);
			RECT rt;
			rt.right=width;
			rt.bottom =height;
			FillRect(hdc,&rt,(HBRUSH)GetStockObject(WHITE_BRUSH));
			Graphics grfx(hdc);
			Pen  pen(Color(255, 0, 0));
			Bitmap *bmp=new Bitmap(width,height);
			Graphics gbmp(bmp);

			UINT* pixels;
			BitmapData bitmapData;
			Rect rect(0, 0, width, height);
			DWORD tm1 = GetTickCount();
			bmp->LockBits(				//        Bitmap-
				&rect,
				ImageLockModeWrite,
				PixelFormat32bppARGB,
				&bitmapData);
			pixels = (UINT*)bitmapData.Scan0;	//      



		   time1=GetTickCount();
		   for (m=0; m<100; m++)
		   {
			   for (int n=0; n<maxpoints; n++)
			   {
				   points[n].x=rand()%(width-1);
				   points[n].y=rand()%(height-1);
				   
			   }
			   Fill(pixels,width,height,points,maxpoints,0xff000000);
		   }
		   
		   time2=GetTickCount();
		   wsprintf(s,TEXT(" \n %i"),time2-time1);
		   MessageBox(hWnd,s,s,MB_OK);
	

			bmp->UnlockBits(&bitmapData);	//    
			grfx.DrawImage(bmp, 0, 0);		//   Bitmap-
			ReleaseDC(hWnd,hdc);
			countpoints=maxpoints;
			delete bmp;
			 }
		   break;
	   case IDM_ABOUT:
		   DialogBox(hInst,(LPCTSTR)IDD_ABOUT,hWnd,(DLGPROC)AboutDialogProc);
		   break;
	   default:
		   return DefWindowProc(hWnd, message, wParam, lParam);
	   }
	   break;
   case WM_PAINT:
      hdc = BeginPaint(hWnd, &ps);
      EndPaint(hWnd, &ps);
	  RedrawAll(hWnd);
      return 0;
   case WM_SIZE:	//    
	   width = LOWORD (lParam) ; //    
       height = HIWORD (lParam) ;//    
	   return 0;

   case WM_LBUTTONDOWN:
	   POINT point;
	   point.x=LOWORD(lParam);
	   point.y=HIWORD(lParam);
	   if (countpoints>=maxpoints)
	   {
		   POINT * newpoints=new POINT[maxpoints*2];
		   if (!newpoints) PostQuitMessage(1);
		   memcpy(newpoints, points,sizeof(POINT)*countpoints);
		   delete [] points;
		   points=newpoints;
		   maxpoints*=2;
	   }
	   points[countpoints]=point;
	   countpoints++;

	   if (countpoints>2) RedrawAll(hWnd);
	   break;
   case WM_RBUTTONDOWN:
	   scalef.x=LOWORD(lParam);
	   scalef.y=HIWORD(lParam);
	   RedrawAll(hWnd);
	   break;
   case WM_DESTROY:
	   delete [] points;
      PostQuitMessage(0);
      return 0;
   default:
      return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
} // WndProc